• Codeforces Round #563 (Div. 2) D. Ehab and the Expected XOR Problem(好题)(构造)(根据前缀亦或和反推数列)


    D. Ehab and the Expected XOR Problem

    time limit per test

    1 second

    memory limit per test

    256 megabytes

    input

    standard input

    output

    standard output

    Given two integers nn and xx, construct an array that satisfies the following conditions:

    • for any element aiai in the array, 1≤ai<2n1≤ai<2n;
    • there is no non-empty subsegment with bitwise XOR equal to 00 or xx,
    • its length ll should be maximized.

    A sequence bb is a subsegment of a sequence aa if bb can be obtained from aa by deletion of several (possibly, zero or all) elements from the beginning and several (possibly, zero or all) elements from the end.

    Input

    The only line contains two integers nn and xx (1≤n≤181≤n≤18, 1≤x<2181≤x<218).

    Output

    The first line should contain the length of the array ll.

    If ll is positive, the second line should contain ll space-separated integers a1a1, a2a2, ……, alal (1≤ai<2n1≤ai<2n) — the elements of the array aa.

    If there are multiple solutions, print any of them.

    Examples

    input

    Copy

    3 5
    

    output

    Copy

    3
    6 1 3

    input

    Copy

    2 4
    

    output

    Copy

    3
    1 3 1 

    input

    Copy

    1 1
    

    output

    Copy

    0
    

    Note

    In the first example, the bitwise XOR of the subsegments are {6,7,4,1,2,3}{6,7,4,1,2,3}.

    对于此题我们一定要了解前缀异或和的性质 不然很难构造出这种数列

    那么对于本题该如何构造呢

    我们考虑前缀异或和 

    题目要求我们任意的字串不能是0或x

    那么也就是说任意的前缀和都是不同的(否则就会出现等于0)

    且任意的前缀和亦或起来不能等于k

    所以对于一个数用过之后那么x^k 就无法再次使用 否则区间就会出现亦或和等于k的情况

    因此我们只需跑一边循环把所有的前缀找出来

    那么根据我们所得的前缀就很容易

    推出所需要构造的数列了

    #include<bits/stdc++.h>
    int vis[500000];
    int main()
    {
        int n,k;
        scanf("%d%d",&n,&k);
        vis[k]=2;
        int cnt=0;
       for(int i=1;i<1<<n;i++)
       {
           if(vis[i]==2) continue;
           vis[i^k]=2;
           cnt++;
       }
       printf("%d
    ",cnt);
       int pos=0;
       for(int i=1;i<1<<n;i++)
       {
           if(vis[i]==0) printf("%d ",i^pos),pos=i;
       }
    }
  • 相关阅读:
    如何实现文字两端对齐?
    三目运算符的复杂运算(条件嵌套判断)
    微信小程序实现图片上传,预览,删除
    微信小程序滚动条返回顶部
    vue+axios下载文件的实现
    java script 运算符
    关于placeholder提示内容出现在textarea底部问题
    js基础知识
    java script 字符串
    java script 函数
  • 原文地址:https://www.cnblogs.com/caowenbo/p/11852253.html
Copyright © 2020-2023  润新知